repack: place temporary packs under .git/objects/pack/
[alt-git.git] / git-repack.sh
blobd21b274de9a8a24684d86d71f1c224cce9dda113
1 #!/bin/sh
3 # Copyright (c) 2005 Linus Torvalds
6 OPTIONS_KEEPDASHDASH=
7 OPTIONS_SPEC="\
8 git repack [options]
9 --
10 a pack everything in a single pack
11 A same as -a, and turn unreachable objects loose
12 d remove redundant packs, and run git-prune-packed
13 f pass --no-reuse-object to git-pack-objects
14 n do not run git-update-server-info
15 q,quiet be quiet
16 l pass --local to git-pack-objects
17 Packing constraints
18 window= size of the window used for delta compression
19 window-memory= same as the above, but limit memory size instead of entries count
20 depth= limits the maximum delta depth
21 max-pack-size= maximum size of each packfile
23 SUBDIRECTORY_OK='Yes'
24 . git-sh-setup
26 no_update_info= all_into_one= remove_redundant= unpack_unreachable=
27 local= no_reuse= extra=
28 while test $# != 0
30 case "$1" in
31 -n) no_update_info=t ;;
32 -a) all_into_one=t ;;
33 -A) all_into_one=t
34 unpack_unreachable=--unpack-unreachable ;;
35 -d) remove_redundant=t ;;
36 -q) GIT_QUIET=t ;;
37 -f) no_reuse=--no-reuse-object ;;
38 -l) local=--local ;;
39 --max-pack-size|--window|--window-memory|--depth)
40 extra="$extra $1=$2"; shift ;;
41 --) shift; break;;
42 *) usage ;;
43 esac
44 shift
45 done
47 case "`git config --bool repack.usedeltabaseoffset || echo true`" in
48 true)
49 extra="$extra --delta-base-offset" ;;
50 esac
52 PACKDIR="$GIT_OBJECT_DIRECTORY/pack"
53 PACKTMP="$PACKDIR/.tmp-$$-pack"
54 rm -f "$PACKTMP"-*
55 trap 'rm -f "$PACKTMP"-*' 0 1 2 3 15
57 # There will be more repacking strategies to come...
58 case ",$all_into_one," in
59 ,,)
60 args='--unpacked --incremental'
62 ,t,)
63 args= existing=
64 if [ -d "$PACKDIR" ]; then
65 for e in `cd "$PACKDIR" && find . -type f -name '*.pack' \
66 | sed -e 's/^\.\///' -e 's/\.pack$//'`
68 if [ -e "$PACKDIR/$e.keep" ]; then
69 : keep
70 else
71 existing="$existing $e"
73 done
74 if test -n "$existing" -a -n "$unpack_unreachable" -a \
75 -n "$remove_redundant"
76 then
77 args="$args $unpack_unreachable"
81 esac
83 mkdir -p "$PACKDIR" || exit
85 args="$args $local ${GIT_QUIET:+-q} $no_reuse$extra"
86 names=$(git pack-objects --keep-true-parents --honor-pack-keep --non-empty --all --reflog $args </dev/null "$PACKTMP") ||
87 exit 1
88 if [ -z "$names" ]; then
89 say Nothing new to pack.
92 # Ok we have prepared all new packfiles.
94 # First see if there are packs of the same name and if so
95 # if we can move them out of the way (this can happen if we
96 # repacked immediately after packing fully.
97 rollback=
98 failed=
99 for name in $names
101 for sfx in pack idx
103 file=pack-$name.$sfx
104 test -f "$PACKDIR/$file" || continue
105 rm -f "$PACKDIR/old-$file" &&
106 mv "$PACKDIR/$file" "$PACKDIR/old-$file" || {
107 failed=t
108 break
110 rollback="$rollback $file"
111 done
112 test -z "$failed" || break
113 done
115 # If renaming failed for any of them, roll the ones we have
116 # already renamed back to their original names.
117 if test -n "$failed"
118 then
119 rollback_failure=
120 for file in $rollback
122 mv "$PACKDIR/old-$file" "$PACKDIR/$file" ||
123 rollback_failure="$rollback_failure $file"
124 done
125 if test -n "$rollback_failure"
126 then
127 echo >&2 "WARNING: Some packs in use have been renamed by"
128 echo >&2 "WARNING: prefixing old- to their name, in order to"
129 echo >&2 "WARNING: replace them with the new version of the"
130 echo >&2 "WARNING: file. But the operation failed, and"
131 echo >&2 "WARNING: attempt to rename them back to their"
132 echo >&2 "WARNING: original names also failed."
133 echo >&2 "WARNING: Please rename them in $PACKDIR manually:"
134 for file in $rollback_failure
136 echo >&2 "WARNING: old-$file -> $file"
137 done
139 exit 1
142 # Now the ones with the same name are out of the way...
143 fullbases=
144 for name in $names
146 fullbases="$fullbases pack-$name"
147 chmod a-w "$PACKTMP-$name.pack"
148 chmod a-w "$PACKTMP-$name.idx"
149 mv -f "$PACKTMP-$name.pack" "$PACKDIR/pack-$name.pack" &&
150 mv -f "$PACKTMP-$name.idx" "$PACKDIR/pack-$name.idx" ||
151 exit
152 done
154 # Remove the "old-" files
155 for name in $names
157 rm -f "$PACKDIR/old-pack-$name.idx"
158 rm -f "$PACKDIR/old-pack-$name.pack"
159 done
161 # End of pack replacement.
163 if test "$remove_redundant" = t
164 then
165 # We know $existing are all redundant.
166 if [ -n "$existing" ]
167 then
168 ( cd "$PACKDIR" &&
169 for e in $existing
171 case " $fullbases " in
172 *" $e "*) ;;
173 *) rm -f "$e.pack" "$e.idx" "$e.keep" ;;
174 esac
175 done
178 git prune-packed ${GIT_QUIET:+-q}
181 case "$no_update_info" in
182 t) : ;;
183 *) git update-server-info ;;
184 esac